#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <pthread.h>
#include <arpa/inet.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "datahdl.h"
#include "nameconv.h"
#include "thpkt.h"

gint					grab_list_row;
gint					port_list_row;
gint					cont_list_row;
gint					site_list_row;
gint					port_list_num = 0;
gint					cont_list_num = 0;
gint					site_list_num = 0;

gboolean
on_djstopctl_delete_event              (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{ 
	gtk_main_quit();
	return FALSE;
}


void
on_open_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

	djsc_load_ini();

	djsc_load_data( "port_list.dat", mainwin_port_clist, DJSC_PORT);	
	djsc_load_data( "cont_list.dat", mainwin_cont_clist, DJSC_CONT);
	djsc_load_data( "site_list.dat", mainwin_site_clist, DJSC_SITE);	

}


void
on_save_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	FILE				*fp;
	gint				ncla;
	char				*cldata;
	char				*cr = "# Created by djstopctl version 0.1 #\n";
	
	
	

	if ( ( fp = fopen("port_list.dat", "w") ) == NULL) {
		g_print( "Can't open port_list.dat\n");
	}
	else{

		fprintf( fp, cr);		
		
		for( ncla = 0 ; ncla < port_list_num; ncla ++){
			
			gtk_clist_get_text( GTK_CLIST( mainwin_port_clist), ncla, 0, &cldata);
			fprintf( fp, "%s\t\t\t\t\t",cldata );		
			gtk_clist_get_text( GTK_CLIST( mainwin_port_clist), ncla, 1, &cldata);		
			fprintf( fp, "%s\n" ,cldata);
		}
		fclose( fp);
	}
	

	
	if ( ( fp = fopen("cont_list.dat", "w") ) == NULL) {
		g_print( "Can't open cont_list.dat\n");
	}
	else{
		
		fprintf( fp, cr);		
		
		for( ncla = 0 ; ncla < cont_list_num; ncla ++){
		
			gtk_clist_get_text( GTK_CLIST( mainwin_cont_clist), ncla, 0, &cldata);
			fprintf( fp, "%s\t\t\t",cldata );	
			gtk_clist_get_text( GTK_CLIST( mainwin_cont_clist), ncla, 1, &cldata);
			fprintf( fp, "%s\t\t\t",cldata );				
			gtk_clist_get_text( GTK_CLIST( mainwin_cont_clist), ncla, 2, &cldata);		
			fprintf( fp, "%s\n",cldata );
			
		}	
		fclose( fp);			
	}	
	

	
	if ( ( fp = fopen("site_list.dat", "w") ) == NULL) {
		g_print( "Can't open site_list.dat\n");
	}	
	else{
		
		fprintf( fp, cr);			
		
		for( ncla = 0 ; ncla < site_list_num; ncla ++){
			
			gtk_clist_get_text( GTK_CLIST( mainwin_site_clist), ncla, 0, &cldata);
			fprintf( fp, "%s\t\t\t\t\t" ,cldata);		
			gtk_clist_get_text( GTK_CLIST( mainwin_site_clist), ncla, 1, &cldata);		
			fprintf( fp, "%s\n",cldata );
				
		}		
		fclose( fp);	
	}	
	
	

}


void
on_exit_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gtk_main_quit();
}


void
on_new_activate                        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gint					notebook_pagenum;
	
	
	
	
	notebook_pagenum = gtk_notebook_get_current_page( GTK_NOTEBOOK (mainwin_notebook ) );
	

	switch( notebook_pagenum){
		
		case 0:
			return;	
			break;		
		case 1:
			gtk_widget_show( create_insert_port_list (-1));		
			break;
		case 2:
			gtk_widget_show(create_insert_cont_list (-1));
			break;
		case 3:
			gtk_widget_show(create_insert_site_list (-1));		
			break;
	}
			

}


void
on_update_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gint					notebook_pagenum;
	
	
	
	
	notebook_pagenum = gtk_notebook_get_current_page( GTK_NOTEBOOK (mainwin_notebook ) );
	

	switch( notebook_pagenum){
		
		case 0:
			return;
			break;		
		case 1:
			gtk_widget_show( create_insert_port_list (DJSC_PORT));		
			break;
		case 2:
			gtk_widget_show(create_insert_cont_list (DJSC_CONT));
			break;
		case 3:
			gtk_widget_show(create_insert_site_list (DJSC_SITE));		
			break;		

	}	
	

}


void
on_cut_activate                        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gint						notebook_pagenum;

	
	
	
	notebook_pagenum = gtk_notebook_get_current_page( GTK_NOTEBOOK (mainwin_notebook ) );	
	
	switch( notebook_pagenum){
		
		case 0:
			return;
			break;		
		case 1:
			if( ( port_list_num == 0) || ( port_list_num < port_list_row )) return;
			break;
		case 2:
			if( ( cont_list_num == 0)|| (cont_list_num < cont_list_row)) return;
			break;
		case 3:
			if(( site_list_num == 0)|| ( site_list_num < site_list_row)) return;	
			break;		

	}	
	gtk_widget_show( create_delete_list ());

}


void
on_mainwin_menu_edit_ref_activate      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	
	char						*szdata[6];
	char						*srcip;
	char						*dstip;
	char						srcport[10];
	char						dstport[10];
	
	
	struct	my_link_list		*data = NULL;
			

	 gtk_clist_clear( GTK_CLIST( mainwin_infograb_clist));

	pthread_mutex_lock( &pkt_data_mutex);
	
	for( data = pkt_data; data != NULL; data = data->next){
		
		srcip = strdup(  (char *)inet_ntoa( *( ( struct in_addr *) &data->srcip)));
		dstip = strdup(  (char *)inet_ntoa( *( ( struct in_addr *) &data->dstip)));
		sprintf( srcport, "%hu", ntohs( data->srcport));
		sprintf( dstport, "%hu", ntohs( data->dstport));


		szdata[0] = srcip;
		szdata[1] = srcport;
		szdata[2] = data->srchostname;
		szdata[3] = dstip;
		szdata[4] = dstport;
		szdata[5] = data->dsthostname;
		
		gtk_clist_append( GTK_CLIST ( mainwin_infograb_clist), szdata);
		
	}
					
	pthread_mutex_unlock( &pkt_data_mutex);				

}


void
on_about_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gtk_widget_show( create_about ());
}


void
on_mainwin_toolbar_btt_new_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
	on_new_activate( NULL, NULL);                      

}


void
on_mainwin_toolbar_btt_cut_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
	on_cut_activate                        ( NULL, NULL);
}


void
on_mainwin_toolbar_btt_update_clicked  (GtkButton       *button,
                                        gpointer         user_data)
{
	on_update_activate  ( NULL, NULL);
}


void
on_mainwin_toolbar_btt_refresh_clicked (GtkButton       *button,
                                        gpointer         user_data)
{
	on_mainwin_menu_edit_ref_activate  ( NULL, NULL);
}


void
on_clist8_start_selection              (GtkCList        *clist,
                                        gpointer         user_data)
{

}


void
on_clist8_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	
  gtk_widget_show (	create_dia_grablist_insert ( row));
  grab_list_row = row;
	
}


void
on_clist8_end_selection                (GtkCList        *clist,
                                        gpointer         user_data)
{

}


void
on_clist5_end_selection                (GtkCList        *clist,
                                        gpointer         user_data)
{

}


void
on_clist5_start_selection              (GtkCList        *clist,
                                        gpointer         user_data)
{

}


void
on_clist5_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	port_list_row = row;
}


void
on_clist6_end_selection                (GtkCList        *clist,
                                        gpointer         user_data)
{

}


void
on_clist6_start_selection              (GtkCList        *clist,
                                        gpointer         user_data)
{

}


void
on_clist6_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	cont_list_row = row;
}


void
on_clist7_end_selection                (GtkCList        *clist,
                                        gpointer         user_data)
{

}


void
on_clist7_start_selection              (GtkCList        *clist,
                                        gpointer         user_data)
{

}


void
on_clist7_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	site_list_row = row;
}


void
on_cont_dia_ok_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	struct	my_widget_bundle			*wbp;
	char								*cldata[3];

	
	wbp = user_data;	

	cldata[0] =  gtk_entry_get_text( GTK_ENTRY( wbp->item1));
	cldata[1] =  gtk_entry_get_text( GTK_ENTRY( wbp->item2));
	cldata[2] =  gtk_entry_get_text( GTK_ENTRY( wbp->item3));	
	
	if(  cldata[0][0] != '\0' && cldata[1][0] != '\0' && cldata[2][0] != '\0') 	{
		if( wbp->status != -1){
			
			gtk_clist_set_text( GTK_CLIST( mainwin_cont_clist), wbp->status, 0, cldata[0]);
			gtk_clist_set_text( GTK_CLIST( mainwin_cont_clist), wbp->status, 1, cldata[1]);
			gtk_clist_set_text( GTK_CLIST( mainwin_cont_clist), wbp->status, 2, cldata[2]);			
			
		}
		else{
			gtk_clist_append( GTK_CLIST( mainwin_cont_clist), cldata);
			cont_list_num++;
		}
	}
		
	gnome_dialog_close( GNOME_DIALOG( wbp->item4));
	free( wbp);	

}


void
on_cont_dia_adp_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	struct	my_widget_bundle			*wbp;
	char								*cldata[3];

	
	wbp = user_data;	

	cldata[0] =  gtk_entry_get_text( GTK_ENTRY( wbp->item1));
	cldata[1] =  gtk_entry_get_text( GTK_ENTRY( wbp->item2));
	cldata[2] =  gtk_entry_get_text( GTK_ENTRY( wbp->item3));	
	
	
	if(  cldata[0][0] != '\0' && cldata[1][0] != '\0' && cldata[2][0] != '\0') 	{
		if( wbp->status != -1){
			
			gtk_clist_set_text( GTK_CLIST( mainwin_cont_clist), wbp->status, 0, cldata[0]);
			gtk_clist_set_text( GTK_CLIST( mainwin_cont_clist), wbp->status, 1, cldata[1]);
			gtk_clist_set_text( GTK_CLIST( mainwin_cont_clist), wbp->status, 2, cldata[2]);			
			
		}
		else{			
			gtk_clist_append( GTK_CLIST( mainwin_cont_clist), cldata);
			cont_list_num++;
		}
	}
	gnome_dialog_close( GNOME_DIALOG( wbp->item4));
	free( wbp);	

}


void
on_cont_dia_cc_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

	struct	my_widget_bundle			*wbp;
	
	wbp = user_data;	

	gnome_dialog_close( GNOME_DIALOG( wbp->item4));
	free( wbp);	
	

}


void
on_port_dia_ok_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	
	struct	my_widget_bundle			*wbp;
	char								*cldata[2];

	
	wbp = user_data;	

	cldata[0] =  gtk_entry_get_text( GTK_ENTRY( wbp->item1));
	cldata[1] =  gtk_entry_get_text( GTK_ENTRY( wbp->item2));
	
	
	
	if(  cldata[0][0] != '\0' && cldata[1][0] != '\0'){
		if( wbp->status != -1){
			
			gtk_clist_set_text( GTK_CLIST( mainwin_port_clist), wbp->status, 0, cldata[0]);
			gtk_clist_set_text( GTK_CLIST( mainwin_port_clist), wbp->status, 1, cldata[1]);
			
		}
		else{			
			gtk_clist_append( GTK_CLIST( mainwin_port_clist), cldata);
			port_list_num++;
		}
	}
			
	gnome_dialog_close( GNOME_DIALOG( wbp->item3));
	free( wbp);	

}


void
on_port_dia_adp_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	struct	my_widget_bundle			*wbp;
	char								*cldata[2];

	
	wbp = user_data;	

	cldata[0] =  gtk_entry_get_text( GTK_ENTRY( wbp->item1));
	cldata[1] =  gtk_entry_get_text( GTK_ENTRY( wbp->item2));
	
	if(  cldata[0][0] != '\0' && cldata[1][0] != '\0'){
		if( wbp->status != -1){
			
			gtk_clist_set_text( GTK_CLIST( mainwin_port_clist), wbp->status, 0, cldata[0]);
			gtk_clist_set_text( GTK_CLIST( mainwin_port_clist), wbp->status, 1, cldata[1]);
			
		}
		else{			
			gtk_clist_append( GTK_CLIST( mainwin_port_clist), cldata);
			port_list_num++;
		}
	}
		
	gnome_dialog_close( GNOME_DIALOG( wbp->item3));


}


void
on_port_dia_cc_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	struct	my_widget_bundle			*wbp;
	
	wbp = user_data;	

	gnome_dialog_close( GNOME_DIALOG( wbp->item3));
	free( wbp);	

}


void
on_site_dia_ok_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	
	struct	my_widget_bundle			*wbp;
	char								*cldata[2];

	

	
	wbp = user_data;	

	 cldata[0] = gtk_entry_get_text( GTK_ENTRY( wbp->item1));
	 cldata[1] = gtk_entry_get_text( GTK_ENTRY( wbp->item2));
	
	
	if(  cldata[0][0] != '\0' && cldata[1][0] != '\0'){
		if( wbp->status != -1){
			
			gtk_clist_set_text( GTK_CLIST( mainwin_site_clist), wbp->status, 0, cldata[0]);
			gtk_clist_set_text( GTK_CLIST( mainwin_site_clist), wbp->status, 1, cldata[1]);
			
		}
		else{			
			gtk_clist_append( GTK_CLIST( mainwin_site_clist), cldata);
			site_list_num++;
		}
	}
			
	gnome_dialog_close( GNOME_DIALOG( wbp->item3));	
	free( wbp);

}


void
on_site_dia_adp_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	struct	my_widget_bundle			*wbp;
	char								*cldata[2];

	

	
	wbp = user_data;	

	 cldata[0] = gtk_entry_get_text( GTK_ENTRY( wbp->item1));
	 cldata[1] = gtk_entry_get_text( GTK_ENTRY( wbp->item2));
	
	if(  cldata[0][0] != '\0' && cldata[1][0] != '\0'){
		if( wbp->status != -1){
			
			gtk_clist_set_text( GTK_CLIST( mainwin_site_clist), wbp->status, 0, cldata[0]);
			gtk_clist_set_text( GTK_CLIST( mainwin_site_clist), wbp->status, 1, cldata[1]);
			
		}
		else{			
			gtk_clist_append( GTK_CLIST( mainwin_site_clist), cldata);
			site_list_num++;
		}
	}
	gnome_dialog_close( GNOME_DIALOG( wbp->item3));	

}


void
on_site_dia_cc_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	struct	my_widget_bundle			*wbp;
	
	wbp = user_data;	

	gnome_dialog_close( GNOME_DIALOG( wbp->item3));
	free( wbp);		

}


void
on_dia_delete_ok_btt_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{

	struct	my_widget_bundle			*wbp;	
	
	

	
	wbp = user_data;	
	switch( wbp->status){
		
		case 0:
			return;
			break;		
		case 1:
			gtk_clist_remove( GTK_CLIST( mainwin_port_clist), wbp->status2);				
			port_list_num --;		
			if( port_list_row != 0) port_list_row --;				
			break;
		case 2:
			gtk_clist_remove( GTK_CLIST( mainwin_cont_clist), wbp->status2);		
			cont_list_num --;		
			if( cont_list_row != 0) cont_list_row --;			
			break;
		case 3:
			gtk_clist_remove( GTK_CLIST( mainwin_site_clist), wbp->status2);
			site_list_num --;		
			if( site_list_row != 0) site_list_row --;			
			break;
	}
	gnome_dialog_close( GNOME_DIALOG( wbp->item1));
	free( wbp);			

}


void
on_dia_delete_cc_btt_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
	struct	my_widget_bundle			*wbp;
		
	wbp = user_data;	
	gnome_dialog_close( GNOME_DIALOG( wbp->item1));
	free( wbp);			
}


void
on_dia_dtist_ok_btt_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	struct	my_widget_bundle			*wbp;
	char								*szdata[6];
	char								*sadata[3];
	char								*rep = "Replace-here";
	gint								lna;

	
	
	
	wbp = user_data;
		
	  for( lna =0; lna < 6; lna++){
	  
	 gtk_clist_get_text( GTK_CLIST ( mainwin_infograb_clist), grab_list_row, lna, ( szdata + lna));
		  
	 }
	 
	if (GTK_TOGGLE_BUTTON ( wbp->item1 )->active){		
		
		sadata[0] = szdata[1];
		sadata[1] = rep;		
		gtk_clist_append( GTK_CLIST( mainwin_port_clist), sadata);
		port_list_num++;		
		
	}
	if (GTK_TOGGLE_BUTTON ( wbp->item2 )->active){
		
		sadata[0] = rep;
		sadata[1] = szdata[2];
		sadata[2] = szdata[0];
		gtk_clist_append( GTK_CLIST( mainwin_cont_clist), sadata);		
		cont_list_num++;
		
	}
	if (GTK_TOGGLE_BUTTON ( wbp->item3 )->active){
	
		sadata[0] = szdata[2];
		sadata[1] = szdata[0];				
		gtk_clist_append( GTK_CLIST( mainwin_site_clist), sadata);		
		site_list_num++;
		
	}
	if (GTK_TOGGLE_BUTTON ( wbp->item4 )->active){
		sadata[0] = szdata[4];
		sadata[1] = rep;		
		gtk_clist_append( GTK_CLIST( mainwin_port_clist), sadata);		
		port_list_num++;
		
	}
	if (GTK_TOGGLE_BUTTON ( wbp->item5 )->active){

		
		sadata[0] = rep;
		sadata[1] = szdata[5];
		sadata[2] = szdata[3];
		gtk_clist_append( GTK_CLIST( mainwin_cont_clist), sadata);				
		cont_list_num++;
		
	}
	if (GTK_TOGGLE_BUTTON ( wbp->item6 )->active){		
		
		sadata[0] = szdata[5];
		sadata[1] = szdata[3];				
		gtk_clist_append( GTK_CLIST( mainwin_site_clist), sadata);				
		site_list_num++;		
		
	}	
	
	gnome_dialog_close( GNOME_DIALOG( wbp->item7));
	free( wbp);		
}


void
on_dia_dtist_adp_btt_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
	struct	my_widget_bundle			*wbp;
	char								*szdata[6];
	char								*sadata[3];
	char								*rep = "Replace here";
	gint								lna;


	
	wbp = user_data;
	
	 for( lna =0; lna < 6; lna++){
	  
	 gtk_clist_get_text( GTK_CLIST ( mainwin_infograb_clist), grab_list_row, lna, ( szdata + lna));
		  
	 }
	 
		 
	if (GTK_TOGGLE_BUTTON ( wbp->item1 )->active){		
		
		sadata[0] = szdata[1];
		sadata[1] = rep;		
		gtk_clist_append( GTK_CLIST( mainwin_port_clist), sadata);
		port_list_num++;		
		
	}
	if (GTK_TOGGLE_BUTTON ( wbp->item2 )->active){
		
		sadata[0] = rep;
		sadata[1] = szdata[2];
		sadata[2] = szdata[0];
		gtk_clist_append( GTK_CLIST( mainwin_cont_clist), sadata);		
		cont_list_num++;
		
	}
	if (GTK_TOGGLE_BUTTON ( wbp->item3 )->active){
	
		sadata[0] = szdata[2];
		sadata[1] = szdata[0];				
		gtk_clist_append( GTK_CLIST( mainwin_site_clist), sadata);		
		site_list_num++;
		
	}
	if (GTK_TOGGLE_BUTTON ( wbp->item4 )->active){
		sadata[0] = szdata[4];
		sadata[1] = rep;		
		gtk_clist_append( GTK_CLIST( mainwin_port_clist), sadata);		
		port_list_num++;
		
	}
	if (GTK_TOGGLE_BUTTON ( wbp->item5 )->active){

		
		sadata[0] = rep;
		sadata[1] = szdata[5];
		sadata[2] = szdata[3];
		gtk_clist_append( GTK_CLIST( mainwin_cont_clist), sadata);				
		cont_list_num++;
		
	}
	if (GTK_TOGGLE_BUTTON ( wbp->item6 )->active){		
		
		sadata[0] = szdata[5];
		sadata[1] = szdata[3];				
		gtk_clist_append( GTK_CLIST( mainwin_site_clist), sadata);				
		site_list_num++;
		
	}	
	
}


void
on_dia_dtist_cc_btt_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	struct	my_widget_bundle			*wbp;
	
	wbp = user_data;	

	gnome_dialog_close( GNOME_DIALOG( wbp->item7));
	free( wbp);	

}


gboolean
insert_data_obj_del              (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

	free( user_data);
	return FALSE;
}
