
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"


GtkWidget *mainwin_notebook;
GtkWidget *mainwin_infograb_clist;
GtkWidget *mainwin_port_clist;
GtkWidget *mainwin_cont_clist;
GtkWidget *mainwin_site_clist;
  
static GnomeUIInfo file_menu_uiinfo[] =
{
  GNOMEUIINFO_MENU_OPEN_ITEM (on_open_activate, NULL),
  GNOMEUIINFO_MENU_SAVE_ITEM (on_save_activate, NULL),
  GNOMEUIINFO_SEPARATOR,
  GNOMEUIINFO_MENU_EXIT_ITEM (on_exit_activate, NULL),
  GNOMEUIINFO_END
};

static GnomeUIInfo _____e_1_menu_uiinfo[] =
{
  GNOMEUIINFO_MENU_NEW_ITEM (N_("\303\337\260\241(_N)"), NULL, on_new_activate, NULL),
  {
    GNOME_APP_UI_ITEM, N_("\272\257\260\346(_U)"),
    NULL,
    on_update_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_CONVERT,
    0, 0, NULL
  },
  GNOMEUIINFO_MENU_CUT_ITEM (on_cut_activate, NULL),
  GNOMEUIINFO_SEPARATOR,
  {
    GNOME_APP_UI_ITEM, N_("\300\347\273\375(_R)"),
    NULL,
    on_mainwin_menu_edit_ref_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_REFRESH,
    0, 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo help_menu_uiinfo[] =
{
  GNOMEUIINFO_MENU_ABOUT_ITEM (on_about_activate, NULL),
  GNOMEUIINFO_END
};

static GnomeUIInfo mainwin_menubar_uiinfo[] =
{
  GNOMEUIINFO_MENU_FILE_TREE (file_menu_uiinfo),
  GNOMEUIINFO_MENU_EDIT_TREE (_____e_1_menu_uiinfo),
  GNOMEUIINFO_MENU_HELP_TREE (help_menu_uiinfo),
  GNOMEUIINFO_END
};

GtkWidget*
create_djstopctl (void)
{
  GtkWidget *djstopctl;
  GtkWidget *vbox11;
  GtkWidget *mainwin_menubar;
  GtkWidget *mainwin_toolbar;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *mainwin_toolbar_btt_new;
  GtkWidget *mainwin_toolbar_btt_cut;
  GtkWidget *mainwin_toolbar_btt_update;
  GtkWidget *mainwin_toolbar_btt_refresh;
  GtkWidget *scrolledwindow14;
  GtkWidget *mainwin_infograb_clist_srcip;
  GtkWidget *mainwin_infograb_clist_srcport;
  GtkWidget *mainwin_infograb_clist_srchostname;
  GtkWidget *mainwin_infograb_clist_dstip;
  GtkWidget *mainwin_infograb_clist_dstport;
  GtkWidget *mainwin_infograb_clist_dsthostname;
  GtkWidget *mainwin_infograb_page;
  GtkWidget *scrolledwindow15;
  GtkWidget *mainwin_port_clist_port;
  GtkWidget *mainwin_port_clist_prgname;
  GtkWidget *mainwin_port_page;
  GtkWidget *scrolledwindow16;
  GtkWidget *mainwin_cont_clist_dep;
  GtkWidget *mainwin_cont_clist_username;
  GtkWidget *mainwin_cont_clist_ipaddr;
  GtkWidget *mainwin_cont_page;
  GtkWidget *scrolledwindow17;
  GtkWidget *mainwin_site_clist_hostname;
  GtkWidget *mainwin_site_clist_ipaddr;
  GtkWidget *mainwin_site_page;
  GtkWidget *mainwin_statusbar;

  djstopctl = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (djstopctl), "djstopctl", djstopctl);
  gtk_window_set_title (GTK_WINDOW (djstopctl), _("djstop ctl"));

  vbox11 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox11);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "vbox11", vbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox11);
  gtk_container_add (GTK_CONTAINER (djstopctl), vbox11);

  mainwin_menubar = gtk_menu_bar_new ();
  gtk_widget_ref (mainwin_menubar);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_menubar", mainwin_menubar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_menubar);
  gtk_box_pack_start (GTK_BOX (vbox11), mainwin_menubar, FALSE, FALSE, 0);
  gnome_app_fill_menu (GTK_MENU_SHELL (mainwin_menubar), mainwin_menubar_uiinfo,
                       NULL, FALSE, 0);

  gtk_widget_ref (mainwin_menubar_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "file",
                            mainwin_menubar_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "open",
                            file_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "save",
                            file_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "separator1",
                            file_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "exit",
                            file_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (mainwin_menubar_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "_____e_1",
                            mainwin_menubar_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (_____e_1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "new",
                            _____e_1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (_____e_1_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "update",
                            _____e_1_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (_____e_1_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "cut",
                            _____e_1_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (_____e_1_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "separator2",
                            _____e_1_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (_____e_1_menu_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_menu_edit_ref",
                            _____e_1_menu_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (mainwin_menubar_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "help",
                            mainwin_menubar_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (help_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "about",
                            help_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  mainwin_toolbar = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (mainwin_toolbar);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_toolbar", mainwin_toolbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_toolbar);
  gtk_box_pack_start (GTK_BOX (vbox11), mainwin_toolbar, FALSE, FALSE, 0);
  gtk_toolbar_set_space_size (GTK_TOOLBAR (mainwin_toolbar), 3);
  gtk_toolbar_set_space_style (GTK_TOOLBAR (mainwin_toolbar), GTK_TOOLBAR_SPACE_LINE);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (djstopctl, GNOME_STOCK_PIXMAP_NEW);
  mainwin_toolbar_btt_new = gtk_toolbar_append_element (GTK_TOOLBAR (mainwin_toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("New"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (mainwin_toolbar_btt_new);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_toolbar_btt_new", mainwin_toolbar_btt_new,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_toolbar_btt_new);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (djstopctl, GNOME_STOCK_PIXMAP_CUT);
  mainwin_toolbar_btt_cut = gtk_toolbar_append_element (GTK_TOOLBAR (mainwin_toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Cut"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (mainwin_toolbar_btt_cut);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_toolbar_btt_cut", mainwin_toolbar_btt_cut,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_toolbar_btt_cut);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (djstopctl, GNOME_STOCK_PIXMAP_CONVERT);
  mainwin_toolbar_btt_update = gtk_toolbar_append_element (GTK_TOOLBAR (mainwin_toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Update"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (mainwin_toolbar_btt_update);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_toolbar_btt_update", mainwin_toolbar_btt_update,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_toolbar_btt_update);

  gtk_toolbar_append_space (GTK_TOOLBAR (mainwin_toolbar));

  tmp_toolbar_icon = gnome_stock_pixmap_widget (djstopctl, GNOME_STOCK_PIXMAP_REFRESH);
  mainwin_toolbar_btt_refresh = gtk_toolbar_append_element (GTK_TOOLBAR (mainwin_toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Refresh"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (mainwin_toolbar_btt_refresh);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_toolbar_btt_refresh", mainwin_toolbar_btt_refresh,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_toolbar_btt_refresh);

  mainwin_notebook = gtk_notebook_new ();
  gtk_widget_ref (mainwin_notebook);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_notebook", mainwin_notebook,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_notebook);
  gtk_box_pack_start (GTK_BOX (vbox11), mainwin_notebook, TRUE, TRUE, 0);

  scrolledwindow14 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow14);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "scrolledwindow14", scrolledwindow14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow14);
  gtk_container_add (GTK_CONTAINER (mainwin_notebook), scrolledwindow14);

  mainwin_infograb_clist = gtk_clist_new (6);
  gtk_widget_ref (mainwin_infograb_clist);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_infograb_clist", mainwin_infograb_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_infograb_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow14), mainwin_infograb_clist);
  gtk_clist_set_column_width (GTK_CLIST (mainwin_infograb_clist), 0, 91);
  gtk_clist_set_column_width (GTK_CLIST (mainwin_infograb_clist), 1, 49);
  gtk_clist_set_column_width (GTK_CLIST (mainwin_infograb_clist), 2, 78);
  gtk_clist_set_column_width (GTK_CLIST (mainwin_infograb_clist), 3, 76);
  gtk_clist_set_column_width (GTK_CLIST (mainwin_infograb_clist), 4, 52);
  gtk_clist_set_column_width (GTK_CLIST (mainwin_infograb_clist), 5, 80);
  gtk_clist_column_titles_show (GTK_CLIST (mainwin_infograb_clist));

  mainwin_infograb_clist_srcip = gtk_label_new (_("Src ip"));
  gtk_widget_ref (mainwin_infograb_clist_srcip);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_infograb_clist_srcip", mainwin_infograb_clist_srcip,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_infograb_clist_srcip);
  gtk_clist_set_column_widget (GTK_CLIST (mainwin_infograb_clist), 0, mainwin_infograb_clist_srcip);

  mainwin_infograb_clist_srcport = gtk_label_new (_("Src port"));
  gtk_widget_ref (mainwin_infograb_clist_srcport);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_infograb_clist_srcport", mainwin_infograb_clist_srcport,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_infograb_clist_srcport);
  gtk_clist_set_column_widget (GTK_CLIST (mainwin_infograb_clist), 1, mainwin_infograb_clist_srcport);

  mainwin_infograb_clist_srchostname = gtk_label_new (_("Src host name"));
  gtk_widget_ref (mainwin_infograb_clist_srchostname);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_infograb_clist_srchostname", mainwin_infograb_clist_srchostname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_infograb_clist_srchostname);
  gtk_clist_set_column_widget (GTK_CLIST (mainwin_infograb_clist), 2, mainwin_infograb_clist_srchostname);

  mainwin_infograb_clist_dstip = gtk_label_new (_("Dst ip"));
  gtk_widget_ref (mainwin_infograb_clist_dstip);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_infograb_clist_dstip", mainwin_infograb_clist_dstip,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_infograb_clist_dstip);
  gtk_clist_set_column_widget (GTK_CLIST (mainwin_infograb_clist), 3, mainwin_infograb_clist_dstip);

  mainwin_infograb_clist_dstport = gtk_label_new (_("Dst port"));
  gtk_widget_ref (mainwin_infograb_clist_dstport);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_infograb_clist_dstport", mainwin_infograb_clist_dstport,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_infograb_clist_dstport);
  gtk_clist_set_column_widget (GTK_CLIST (mainwin_infograb_clist), 4, mainwin_infograb_clist_dstport);

  mainwin_infograb_clist_dsthostname = gtk_label_new (_("Dst host name"));
  gtk_widget_ref (mainwin_infograb_clist_dsthostname);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_infograb_clist_dsthostname", mainwin_infograb_clist_dsthostname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_infograb_clist_dsthostname);
  gtk_clist_set_column_widget (GTK_CLIST (mainwin_infograb_clist), 5, mainwin_infograb_clist_dsthostname);

  mainwin_infograb_page = gtk_label_new (_("Information grab"));
  gtk_widget_ref (mainwin_infograb_page);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_infograb_page", mainwin_infograb_page,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_infograb_page);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (mainwin_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (mainwin_notebook), 0), mainwin_infograb_page);

  scrolledwindow15 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow15);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "scrolledwindow15", scrolledwindow15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow15);
  gtk_container_add (GTK_CONTAINER (mainwin_notebook), scrolledwindow15);

  mainwin_port_clist = gtk_clist_new (2);
  gtk_widget_ref (mainwin_port_clist);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_port_clist", mainwin_port_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_port_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow15), mainwin_port_clist);
  gtk_clist_set_column_width (GTK_CLIST (mainwin_port_clist), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (mainwin_port_clist), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (mainwin_port_clist));

  mainwin_port_clist_port = gtk_label_new (_("Port"));
  gtk_widget_ref (mainwin_port_clist_port);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_port_clist_port", mainwin_port_clist_port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_port_clist_port);
  gtk_clist_set_column_widget (GTK_CLIST (mainwin_port_clist), 0, mainwin_port_clist_port);

  mainwin_port_clist_prgname = gtk_label_new (_("Program name"));
  gtk_widget_ref (mainwin_port_clist_prgname);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_port_clist_prgname", mainwin_port_clist_prgname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_port_clist_prgname);
  gtk_clist_set_column_widget (GTK_CLIST (mainwin_port_clist), 1, mainwin_port_clist_prgname);

  mainwin_port_page = gtk_label_new (_("Port"));
  gtk_widget_ref (mainwin_port_page);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_port_page", mainwin_port_page,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_port_page);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (mainwin_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (mainwin_notebook), 1), mainwin_port_page);

  scrolledwindow16 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow16);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "scrolledwindow16", scrolledwindow16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow16);
  gtk_container_add (GTK_CONTAINER (mainwin_notebook), scrolledwindow16);

  mainwin_cont_clist = gtk_clist_new (3);
  gtk_widget_ref (mainwin_cont_clist);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_cont_clist", mainwin_cont_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_cont_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow16), mainwin_cont_clist);
  gtk_clist_set_column_width (GTK_CLIST (mainwin_cont_clist), 0, 79);
  gtk_clist_set_column_width (GTK_CLIST (mainwin_cont_clist), 1, 80);
  gtk_clist_set_column_width (GTK_CLIST (mainwin_cont_clist), 2, 80);
  gtk_clist_column_titles_show (GTK_CLIST (mainwin_cont_clist));

  mainwin_cont_clist_dep = gtk_label_new (_("Department"));
  gtk_widget_ref (mainwin_cont_clist_dep);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_cont_clist_dep", mainwin_cont_clist_dep,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_cont_clist_dep);
  gtk_clist_set_column_widget (GTK_CLIST (mainwin_cont_clist), 0, mainwin_cont_clist_dep);

  mainwin_cont_clist_username = gtk_label_new (_("Usr name"));
  gtk_widget_ref (mainwin_cont_clist_username);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_cont_clist_username", mainwin_cont_clist_username,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_cont_clist_username);
  gtk_clist_set_column_widget (GTK_CLIST (mainwin_cont_clist), 1, mainwin_cont_clist_username);

  mainwin_cont_clist_ipaddr = gtk_label_new (_("Ip address"));
  gtk_widget_ref (mainwin_cont_clist_ipaddr);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_cont_clist_ipaddr", mainwin_cont_clist_ipaddr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_cont_clist_ipaddr);
  gtk_clist_set_column_widget (GTK_CLIST (mainwin_cont_clist), 2, mainwin_cont_clist_ipaddr);

  mainwin_cont_page = gtk_label_new (_("Cont"));
  gtk_widget_ref (mainwin_cont_page);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_cont_page", mainwin_cont_page,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_cont_page);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (mainwin_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (mainwin_notebook), 2), mainwin_cont_page);

  scrolledwindow17 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow17);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "scrolledwindow17", scrolledwindow17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow17);
  gtk_container_add (GTK_CONTAINER (mainwin_notebook), scrolledwindow17);

  mainwin_site_clist = gtk_clist_new (2);
  gtk_widget_ref (mainwin_site_clist);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_site_clist", mainwin_site_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_site_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow17), mainwin_site_clist);
  gtk_clist_set_column_width (GTK_CLIST (mainwin_site_clist), 0, 283);
  gtk_clist_set_column_width (GTK_CLIST (mainwin_site_clist), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (mainwin_site_clist));

  mainwin_site_clist_hostname = gtk_label_new (_("Host name"));
  gtk_widget_ref (mainwin_site_clist_hostname);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_site_clist_hostname", mainwin_site_clist_hostname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_site_clist_hostname);
  gtk_clist_set_column_widget (GTK_CLIST (mainwin_site_clist), 0, mainwin_site_clist_hostname);

  mainwin_site_clist_ipaddr = gtk_label_new (_("Ip address"));
  gtk_widget_ref (mainwin_site_clist_ipaddr);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_site_clist_ipaddr", mainwin_site_clist_ipaddr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_site_clist_ipaddr);
  gtk_clist_set_column_widget (GTK_CLIST (mainwin_site_clist), 1, mainwin_site_clist_ipaddr);

  mainwin_site_page = gtk_label_new (_("Site"));
  gtk_widget_ref (mainwin_site_page);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_site_page", mainwin_site_page,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_site_page);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (mainwin_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (mainwin_notebook), 3), mainwin_site_page);

  mainwin_statusbar = gtk_statusbar_new ();
  gtk_widget_ref (mainwin_statusbar);
  gtk_object_set_data_full (GTK_OBJECT (djstopctl), "mainwin_statusbar", mainwin_statusbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mainwin_statusbar);
  gtk_box_pack_start (GTK_BOX (vbox11), mainwin_statusbar, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (djstopctl), "delete_event",
                      GTK_SIGNAL_FUNC (on_djstopctl_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin_toolbar_btt_new), "clicked",
                      GTK_SIGNAL_FUNC (on_mainwin_toolbar_btt_new_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin_toolbar_btt_cut), "clicked",
                      GTK_SIGNAL_FUNC (on_mainwin_toolbar_btt_cut_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin_toolbar_btt_update), "clicked",
                      GTK_SIGNAL_FUNC (on_mainwin_toolbar_btt_update_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin_toolbar_btt_refresh), "clicked",
                      GTK_SIGNAL_FUNC (on_mainwin_toolbar_btt_refresh_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin_infograb_clist), "start_selection",
                      GTK_SIGNAL_FUNC (on_clist8_start_selection),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin_infograb_clist), "select_row",
                      GTK_SIGNAL_FUNC (on_clist8_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin_infograb_clist), "end_selection",
                      GTK_SIGNAL_FUNC (on_clist8_end_selection),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin_port_clist), "end_selection",
                      GTK_SIGNAL_FUNC (on_clist5_end_selection),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin_port_clist), "start_selection",
                      GTK_SIGNAL_FUNC (on_clist5_start_selection),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin_port_clist), "select_row",
                      GTK_SIGNAL_FUNC (on_clist5_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin_cont_clist), "end_selection",
                      GTK_SIGNAL_FUNC (on_clist6_end_selection),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin_cont_clist), "start_selection",
                      GTK_SIGNAL_FUNC (on_clist6_start_selection),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin_cont_clist), "select_row",
                      GTK_SIGNAL_FUNC (on_clist6_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin_site_clist), "end_selection",
                      GTK_SIGNAL_FUNC (on_clist7_end_selection),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin_site_clist), "start_selection",
                      GTK_SIGNAL_FUNC (on_clist7_start_selection),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin_site_clist), "select_row",
                      GTK_SIGNAL_FUNC (on_clist7_select_row),
                      NULL);

  gtk_window_set_default_size  ( GTK_WINDOW( djstopctl), 500,300);

  return djstopctl;
}

GtkWidget*
create_about (void)
{
  const gchar *authors[] = {
    "byongho kim  < -haee-@hanmail.net >",
    NULL
  };
  GtkWidget *about;

  about = gnome_about_new ("Djstopctl", VERSION,
                        "",
                        authors,
                        "DJstop ctl",
                        NULL);
  gtk_object_set_data (GTK_OBJECT (about), "about", about);
  gtk_window_set_modal (GTK_WINDOW (about), TRUE);
  gtk_window_set_wmclass (GTK_WINDOW (about), "", "1");

  return about;
}

GtkWidget*
create_insert_cont_list ( gint	clist_page)
{
  GtkWidget *insert_cont_list;
  GtkWidget *dialog_vbox2;
  GtkWidget *vbox3;
  GtkWidget *department;
  GtkWidget *entry4;
  GtkWidget *usr_name;
  GtkWidget *entry5;
  GtkWidget *ip_addr;
  GtkWidget *entry6;
  GtkWidget *dialog_action_area2;
  GtkWidget *cont_dia_ok;
  GtkWidget *cont_dia_adp;
  GtkWidget *cont_dia_cc;
  char							*szdata;
  struct	my_widget_bundle		*mybdwgt;

	
  insert_cont_list = gnome_dialog_new (_("insert cont list"), NULL);
  gtk_object_set_data (GTK_OBJECT (insert_cont_list), "insert_cont_list", insert_cont_list);
  gtk_window_set_policy (GTK_WINDOW (insert_cont_list), FALSE, FALSE, FALSE);

  dialog_vbox2 = GNOME_DIALOG (insert_cont_list)->vbox;
  gtk_object_set_data (GTK_OBJECT (insert_cont_list), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (insert_cont_list), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), vbox3, TRUE, TRUE, 0);

  department = gtk_label_new (_("department"));
  gtk_widget_ref (department);
  gtk_object_set_data_full (GTK_OBJECT (insert_cont_list), "department", department,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (department);
  gtk_box_pack_start (GTK_BOX (vbox3), department, FALSE, FALSE, 0);

  entry4 = gtk_entry_new ();
  gtk_widget_ref (entry4);
  gtk_object_set_data_full (GTK_OBJECT (insert_cont_list), "entry4", entry4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry4);
  gtk_box_pack_start (GTK_BOX (vbox3), entry4, FALSE, FALSE, 0);

  usr_name = gtk_label_new (_("usr name"));
  gtk_widget_ref (usr_name);
  gtk_object_set_data_full (GTK_OBJECT (insert_cont_list), "usr_name", usr_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (usr_name);
  gtk_box_pack_start (GTK_BOX (vbox3), usr_name, FALSE, FALSE, 0);

  entry5 = gtk_entry_new ();
  gtk_widget_ref (entry5);
  gtk_object_set_data_full (GTK_OBJECT (insert_cont_list), "entry5", entry5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry5);
  gtk_box_pack_start (GTK_BOX (vbox3), entry5, FALSE, FALSE, 0);

  ip_addr = gtk_label_new (_("ip addr"));
  gtk_widget_ref (ip_addr);
  gtk_object_set_data_full (GTK_OBJECT (insert_cont_list), "ip_addr", ip_addr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ip_addr);
  gtk_box_pack_start (GTK_BOX (vbox3), ip_addr, FALSE, FALSE, 0);

  entry6 = gtk_entry_new ();
  gtk_widget_ref (entry6);
  gtk_object_set_data_full (GTK_OBJECT (insert_cont_list), "entry6", entry6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry6);
  gtk_box_pack_start (GTK_BOX (vbox3), entry6, FALSE, FALSE, 0);

  dialog_action_area2 = GNOME_DIALOG (insert_cont_list)->action_area;
  gtk_object_set_data (GTK_OBJECT (insert_cont_list), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area2), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area2), 8);

  gnome_dialog_append_button (GNOME_DIALOG (insert_cont_list), GNOME_STOCK_BUTTON_OK);
  cont_dia_ok = g_list_last (GNOME_DIALOG (insert_cont_list)->buttons)->data;
  gtk_widget_ref (cont_dia_ok);
  gtk_object_set_data_full (GTK_OBJECT (insert_cont_list), "cont_dia_ok", cont_dia_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cont_dia_ok);
  GTK_WIDGET_SET_FLAGS (cont_dia_ok, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (insert_cont_list), GNOME_STOCK_BUTTON_APPLY);
  cont_dia_adp = g_list_last (GNOME_DIALOG (insert_cont_list)->buttons)->data;
  gtk_widget_ref (cont_dia_adp);
  gtk_object_set_data_full (GTK_OBJECT (insert_cont_list), "cont_dia_adp", cont_dia_adp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cont_dia_adp);
  GTK_WIDGET_SET_FLAGS (cont_dia_adp, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (insert_cont_list), GNOME_STOCK_BUTTON_CANCEL);
  cont_dia_cc = g_list_last (GNOME_DIALOG (insert_cont_list)->buttons)->data;
  gtk_widget_ref (cont_dia_cc);
  gtk_object_set_data_full (GTK_OBJECT (insert_cont_list), "cont_dia_cc", cont_dia_cc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cont_dia_cc);
  GTK_WIDGET_SET_FLAGS (cont_dia_cc, GTK_CAN_DEFAULT);

	mybdwgt = ( struct my_widget_bundle *) malloc( sizeof( struct my_widget_bundle));	
	mybdwgt->item1 = entry4;
	mybdwgt->item2 = entry5;
	mybdwgt->item3 = entry6;	
	mybdwgt->item4 = insert_cont_list;
	mybdwgt->status = -1;	
	
	if( clist_page != -1){
		
		gtk_clist_get_text( GTK_CLIST ( mainwin_cont_clist), cont_list_row, 0, &szdata);
		gtk_entry_set_text( GTK_ENTRY( entry4), szdata);
		gtk_clist_get_text( GTK_CLIST ( mainwin_cont_clist), cont_list_row, 1, &szdata);
		gtk_entry_set_text( GTK_ENTRY( entry5), szdata);
		gtk_clist_get_text( GTK_CLIST ( mainwin_cont_clist), cont_list_row, 2, &szdata);
		gtk_entry_set_text( GTK_ENTRY( entry6), szdata);
		mybdwgt->status = cont_list_row;	
	}	
  gtk_signal_connect (GTK_OBJECT (cont_dia_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_cont_dia_ok_clicked),
                      (gpointer) mybdwgt);
  gtk_signal_connect (GTK_OBJECT (cont_dia_adp), "clicked",
                      GTK_SIGNAL_FUNC (on_cont_dia_adp_clicked),
                      (gpointer) mybdwgt);
  gtk_signal_connect (GTK_OBJECT (cont_dia_cc), "clicked",
                      GTK_SIGNAL_FUNC (on_cont_dia_cc_clicked),
                      (gpointer) mybdwgt);
  gtk_signal_connect (GTK_OBJECT ( insert_cont_list), "delete_event",
                      GTK_SIGNAL_FUNC ( insert_data_obj_del),
                      (gpointer) mybdwgt);		 	

  return insert_cont_list;
}

GtkWidget*
create_insert_port_list (  gint	clist_page)
{
  GtkWidget *insert_port_list;
  GtkWidget *vbox4;
  GtkWidget *vbox5;
  GtkWidget *port_port;
  GtkWidget *port_port_ent;
  GtkWidget *port_pgrnm;
  GtkWidget *port_program_ent;
  GtkWidget *hbuttonbox1;
  GtkWidget *port_dia_ok;
  GtkWidget *button7;
  GtkWidget *button8;
struct	my_widget_bundle		*mybdwgt;
  char							*szdata;


  insert_port_list = gnome_dialog_new (_("insert port list"), NULL);
  gtk_object_set_data (GTK_OBJECT (insert_port_list), "insert_port_list", insert_port_list);
  gtk_window_set_policy (GTK_WINDOW (insert_port_list), FALSE, FALSE, FALSE);

  vbox4 = GNOME_DIALOG (insert_port_list)->vbox;
  gtk_object_set_data (GTK_OBJECT (insert_port_list), "vbox4", vbox4);
  gtk_widget_show (vbox4);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (insert_port_list), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_box_pack_start (GTK_BOX (vbox4), vbox5, TRUE, TRUE, 0);

  port_port = gtk_label_new (_("port"));
  gtk_widget_ref (port_port);
  gtk_object_set_data_full (GTK_OBJECT (insert_port_list), "port_port", port_port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (port_port);
  gtk_box_pack_start (GTK_BOX (vbox5), port_port, FALSE, FALSE, 0);

  port_port_ent = gtk_entry_new ();
  gtk_widget_ref (port_port_ent);
  gtk_object_set_data_full (GTK_OBJECT (insert_port_list), "port_port_ent", port_port_ent,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (port_port_ent);
  gtk_box_pack_start (GTK_BOX (vbox5), port_port_ent, FALSE, FALSE, 0);

  port_pgrnm = gtk_label_new (_("program name"));
  gtk_widget_ref (port_pgrnm);
  gtk_object_set_data_full (GTK_OBJECT (insert_port_list), "port_pgrnm", port_pgrnm,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (port_pgrnm);
  gtk_box_pack_start (GTK_BOX (vbox5), port_pgrnm, FALSE, FALSE, 0);

  port_program_ent = gtk_entry_new ();
  gtk_widget_ref (port_program_ent);
  gtk_object_set_data_full (GTK_OBJECT (insert_port_list), "port_program_ent", port_program_ent,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (port_program_ent);
  gtk_box_pack_start (GTK_BOX (vbox5), port_program_ent, FALSE, FALSE, 0);

  hbuttonbox1 = GNOME_DIALOG (insert_port_list)->action_area;
  gtk_object_set_data (GTK_OBJECT (insert_port_list), "hbuttonbox1", hbuttonbox1);
  gtk_widget_show (hbuttonbox1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox1), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbuttonbox1), 8);

  gnome_dialog_append_button (GNOME_DIALOG (insert_port_list), GNOME_STOCK_BUTTON_OK);
  port_dia_ok = g_list_last (GNOME_DIALOG (insert_port_list)->buttons)->data;
  gtk_widget_ref (port_dia_ok);
  gtk_object_set_data_full (GTK_OBJECT (insert_port_list), "port_dia_ok", port_dia_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (port_dia_ok);
  GTK_WIDGET_SET_FLAGS (port_dia_ok, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (insert_port_list), GNOME_STOCK_BUTTON_APPLY);
  button7 = g_list_last (GNOME_DIALOG (insert_port_list)->buttons)->data;
  gtk_widget_ref (button7);
  gtk_object_set_data_full (GTK_OBJECT (insert_port_list), "button7", button7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button7);
  GTK_WIDGET_SET_FLAGS (button7, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (insert_port_list), GNOME_STOCK_BUTTON_CANCEL);
  button8 = g_list_last (GNOME_DIALOG (insert_port_list)->buttons)->data;
  gtk_widget_ref (button8);
  gtk_object_set_data_full (GTK_OBJECT (insert_port_list), "button8", button8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button8);
  GTK_WIDGET_SET_FLAGS (button8, GTK_CAN_DEFAULT);

  	mybdwgt = ( struct my_widget_bundle *) malloc( sizeof( struct my_widget_bundle));	
	mybdwgt->item1 = port_port_ent;
	mybdwgt->item2 = port_program_ent;
	mybdwgt->item3 = insert_port_list;
	mybdwgt->status = -1;	

  
  	if( clist_page != -1){
		
		gtk_clist_get_text( GTK_CLIST ( mainwin_port_clist), port_list_row, 0, &szdata);
		gtk_entry_set_text( GTK_ENTRY(  port_port_ent), szdata);
		gtk_clist_get_text( GTK_CLIST ( mainwin_port_clist), port_list_row, 1, &szdata);
		gtk_entry_set_text( GTK_ENTRY( port_program_ent), szdata);
		mybdwgt->status = port_list_row;	

	}
  
  gtk_signal_connect (GTK_OBJECT (port_dia_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_port_dia_ok_clicked),
                      (gpointer) mybdwgt);
  gtk_signal_connect (GTK_OBJECT (button7), "clicked",
                      GTK_SIGNAL_FUNC (on_port_dia_adp_clicked),
                      (gpointer) mybdwgt);
  gtk_signal_connect (GTK_OBJECT (button8), "clicked",
                      GTK_SIGNAL_FUNC (on_port_dia_cc_clicked),
                      (gpointer) mybdwgt);
  gtk_signal_connect (GTK_OBJECT ( insert_port_list), "delete_event",
                      GTK_SIGNAL_FUNC ( insert_data_obj_del),
                      (gpointer) mybdwgt);
	
  return insert_port_list;
}

GtkWidget*
create_insert_site_list (  gint	clist_page)
{
  GtkWidget *insert_site_list;
  GtkWidget *vbox6;
  GtkWidget *vbox7;
  GtkWidget *site_host_name_title;
  GtkWidget *host_dia_hostname_ent;
  GtkWidget *site_dia_ipaddr_title;
  GtkWidget *site_dia_ipaddr_ent;
  GtkWidget *hbuttonbox2;
  GtkWidget *site_dia_ok_btt;
  GtkWidget *button10;
  GtkWidget *button11;
  struct	my_widget_bundle		*mybdwgt;	
  char							*szdata;
  
  
  insert_site_list = gnome_dialog_new (_("insert site list"), NULL);
  gtk_object_set_data (GTK_OBJECT (insert_site_list), "insert_site_list", insert_site_list);
  gtk_window_set_policy (GTK_WINDOW (insert_site_list), FALSE, FALSE, FALSE);

  vbox6 = GNOME_DIALOG (insert_site_list)->vbox;
  gtk_object_set_data (GTK_OBJECT (insert_site_list), "vbox6", vbox6);
  gtk_widget_show (vbox6);

  vbox7 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox7);
  gtk_object_set_data_full (GTK_OBJECT (insert_site_list), "vbox7", vbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox7);
  gtk_box_pack_start (GTK_BOX (vbox6), vbox7, TRUE, TRUE, 0);

  site_host_name_title = gtk_label_new (_("host name"));
  gtk_widget_ref (site_host_name_title);
  gtk_object_set_data_full (GTK_OBJECT (insert_site_list), "site_host_name_title", site_host_name_title,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (site_host_name_title);
  gtk_box_pack_start (GTK_BOX (vbox7), site_host_name_title, FALSE, FALSE, 0);

  host_dia_hostname_ent = gtk_entry_new ();
  gtk_widget_ref (host_dia_hostname_ent);
  gtk_object_set_data_full (GTK_OBJECT (insert_site_list), "host_dia_hostname_ent", host_dia_hostname_ent,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (host_dia_hostname_ent);
  gtk_box_pack_start (GTK_BOX (vbox7), host_dia_hostname_ent, FALSE, FALSE, 0);

  site_dia_ipaddr_title = gtk_label_new (_("ip addr"));
  gtk_widget_ref (site_dia_ipaddr_title);
  gtk_object_set_data_full (GTK_OBJECT (insert_site_list), "site_dia_ipaddr_title", site_dia_ipaddr_title,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (site_dia_ipaddr_title);
  gtk_box_pack_start (GTK_BOX (vbox7), site_dia_ipaddr_title, FALSE, FALSE, 0);

  site_dia_ipaddr_ent = gtk_entry_new ();
  gtk_widget_ref (site_dia_ipaddr_ent);
  gtk_object_set_data_full (GTK_OBJECT (insert_site_list), "site_dia_ipaddr_ent", site_dia_ipaddr_ent,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (site_dia_ipaddr_ent);
  gtk_box_pack_start (GTK_BOX (vbox7), site_dia_ipaddr_ent, FALSE, FALSE, 0);

  hbuttonbox2 = GNOME_DIALOG (insert_site_list)->action_area;
  gtk_object_set_data (GTK_OBJECT (insert_site_list), "hbuttonbox2", hbuttonbox2);
  gtk_widget_show (hbuttonbox2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox2), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbuttonbox2), 8);

  gnome_dialog_append_button (GNOME_DIALOG (insert_site_list), GNOME_STOCK_BUTTON_OK);
  site_dia_ok_btt = g_list_last (GNOME_DIALOG (insert_site_list)->buttons)->data;
  gtk_widget_ref (site_dia_ok_btt);
  gtk_object_set_data_full (GTK_OBJECT (insert_site_list), "site_dia_ok_btt", site_dia_ok_btt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (site_dia_ok_btt);
  GTK_WIDGET_SET_FLAGS (site_dia_ok_btt, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (insert_site_list), GNOME_STOCK_BUTTON_APPLY);
  button10 = g_list_last (GNOME_DIALOG (insert_site_list)->buttons)->data;
  gtk_widget_ref (button10);
  gtk_object_set_data_full (GTK_OBJECT (insert_site_list), "button10", button10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button10);
  GTK_WIDGET_SET_FLAGS (button10, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (insert_site_list), GNOME_STOCK_BUTTON_CANCEL);
  button11 = g_list_last (GNOME_DIALOG (insert_site_list)->buttons)->data;
  gtk_widget_ref (button11);
  gtk_object_set_data_full (GTK_OBJECT (insert_site_list), "button11", button11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button11);
  GTK_WIDGET_SET_FLAGS (button11, GTK_CAN_DEFAULT);
  
  
	mybdwgt = ( struct my_widget_bundle *) malloc( sizeof( struct my_widget_bundle));	
	mybdwgt->item1 = host_dia_hostname_ent;
	mybdwgt->item2 = site_dia_ipaddr_ent;
	mybdwgt->item3 = insert_site_list;
	mybdwgt->status = -1;	
  	if( clist_page != -1){
		
		gtk_clist_get_text( GTK_CLIST ( mainwin_site_clist), site_list_row, 0, &szdata);
		gtk_entry_set_text( GTK_ENTRY(  host_dia_hostname_ent), szdata);
		gtk_clist_get_text( GTK_CLIST ( mainwin_site_clist), site_list_row, 1, &szdata);
		gtk_entry_set_text( GTK_ENTRY( site_dia_ipaddr_ent), szdata);
		mybdwgt->status = site_list_row;	
	}
    	
  gtk_signal_connect (GTK_OBJECT (site_dia_ok_btt), "clicked",
                      GTK_SIGNAL_FUNC (on_site_dia_ok_clicked),
                      (gpointer) mybdwgt);
  gtk_signal_connect (GTK_OBJECT (button10), "clicked",
                      GTK_SIGNAL_FUNC (on_site_dia_adp_clicked),
                      (gpointer) mybdwgt);
  gtk_signal_connect (GTK_OBJECT (button11), "clicked",
                      GTK_SIGNAL_FUNC (on_site_dia_cc_clicked),
                      (gpointer) mybdwgt);
  gtk_signal_connect (GTK_OBJECT ( insert_site_list), "delete_event",
                      GTK_SIGNAL_FUNC ( insert_data_obj_del),
                      (gpointer) mybdwgt);

  return insert_site_list;
}

GtkWidget*
create_delete_list (void)
{
  GtkWidget *delete_list;
  GtkWidget *dialog_vbox4;
  GtkWidget *delete_message;
  GtkWidget *dialog_action_area4;
  GtkWidget *dia_delete_ok_btt;
  GtkWidget *dia_delete_cc_btt;
  struct	my_widget_bundle		*mybdwgt;	
	  
  delete_list = gnome_dialog_new (_("delete list"), NULL);
  gtk_object_set_data (GTK_OBJECT (delete_list), "delete_list", delete_list);
  gtk_window_set_policy (GTK_WINDOW (delete_list), FALSE, FALSE, FALSE);

  dialog_vbox4 = GNOME_DIALOG (delete_list)->vbox;
  gtk_object_set_data (GTK_OBJECT (delete_list), "dialog_vbox4", dialog_vbox4);
  gtk_widget_show (dialog_vbox4);

  delete_message = gtk_label_new (_("\274\261\305\303\307\317\275\305 \263\273\277\353\300\273 \301\366\277\354\275\303\260\332\275\300\264\317|\261\356?"));
  gtk_widget_ref (delete_message);
  gtk_object_set_data_full (GTK_OBJECT (delete_list), "delete_message", delete_message,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_message);
  gtk_box_pack_start (GTK_BOX (dialog_vbox4), delete_message, FALSE, FALSE, 0);

  dialog_action_area4 = GNOME_DIALOG (delete_list)->action_area;
  gtk_object_set_data (GTK_OBJECT (delete_list), "dialog_action_area4", dialog_action_area4);
  gtk_widget_show (dialog_action_area4);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area4), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area4), 8);

  gnome_dialog_append_button (GNOME_DIALOG (delete_list), GNOME_STOCK_BUTTON_OK);
  dia_delete_ok_btt = g_list_last (GNOME_DIALOG (delete_list)->buttons)->data;
  gtk_widget_ref (dia_delete_ok_btt);
  gtk_object_set_data_full (GTK_OBJECT (delete_list), "dia_delete_ok_btt", dia_delete_ok_btt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dia_delete_ok_btt);
  GTK_WIDGET_SET_FLAGS (dia_delete_ok_btt, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (delete_list), GNOME_STOCK_BUTTON_CANCEL);
  dia_delete_cc_btt = g_list_last (GNOME_DIALOG (delete_list)->buttons)->data;
  gtk_widget_ref (dia_delete_cc_btt);
  gtk_object_set_data_full (GTK_OBJECT (delete_list), "dia_delete_cc_btt", dia_delete_cc_btt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dia_delete_cc_btt);
  GTK_WIDGET_SET_FLAGS (dia_delete_cc_btt, GTK_CAN_DEFAULT);

	mybdwgt = ( struct my_widget_bundle *) malloc( sizeof( struct my_widget_bundle));	
	mybdwgt->item1 = delete_list;
	mybdwgt->status = gtk_notebook_get_current_page( GTK_NOTEBOOK (mainwin_notebook ) );	
	
	switch( mybdwgt->status){
		
		case 0:
			break;		
		case 1:
			mybdwgt->status2 = port_list_row;			
			break;
		case 2:
			mybdwgt->status2 = cont_list_row;			
			break;
		case 3:
			mybdwgt->status2 = site_list_row;				
			break;
	}	

  gtk_signal_connect (GTK_OBJECT (dia_delete_ok_btt), "clicked",
                      GTK_SIGNAL_FUNC (on_dia_delete_ok_btt_clicked),
                       (gpointer) mybdwgt);
  gtk_signal_connect (GTK_OBJECT (dia_delete_cc_btt), "clicked",
                      GTK_SIGNAL_FUNC (on_dia_delete_cc_btt_clicked),
                       (gpointer) mybdwgt);
  gtk_signal_connect (GTK_OBJECT ( delete_list), "delete_event",
                      GTK_SIGNAL_FUNC ( insert_data_obj_del),
                      (gpointer) mybdwgt);


  return delete_list;
}

GtkWidget*
create_dia_grablist_insert (gint user_data)
{
  GtkWidget *dia_grablist_insert;
  GtkWidget *dialog_vbox5;
  GtkWidget *vbox8;
  GtkWidget *vbox9;
  GtkWidget *dia_datainsert_src;
  GtkWidget *hseparator1;
  GtkWidget *hbox1;
  GtkWidget *dia_dtist_src_port;
  GtkWidget *dia_dtist_src_cont;
  GtkWidget *dia_dtist_src_site;
  GtkWidget *vbox10;
  GtkWidget *dia_datainsert_dst;
  GtkWidget *hseparator2;
  GtkWidget *hbox2;
  GtkWidget *dia_dtist_dst_port;
  GtkWidget *dia_dtist_dst_cont;
  GtkWidget *dia_dtist_dst_site;
  GtkWidget *dialog_action_area5;
  GtkWidget *dia_dtist_ok_btt;
  GtkWidget *dia_dtist_adp_btt;
  GtkWidget *dia_dtist_cc_btt;

  char				*szdata[6];
  char				srchostinfo[300];
  char				dsthostinfo[300];

  gint				lna;
  
  struct	my_widget_bundle		*mybdwgt;
	
  
  for( lna =0; lna < 6; lna++){
	  
	  gtk_clist_get_text( GTK_CLIST ( mainwin_infograb_clist), user_data, lna, ( szdata + lna));
	  
  }
  
  sprintf( srchostinfo, "%s(%s):%s", szdata[0], szdata[2], szdata[1]); 
  sprintf( dsthostinfo, "%s(%s):%s", szdata[3], szdata[5], szdata[4]); 
  
  
  dia_grablist_insert = gnome_dialog_new (_("data insert"), NULL);
  gtk_object_set_data (GTK_OBJECT (dia_grablist_insert), "dia_grablist_insert", dia_grablist_insert);
  gtk_window_set_policy (GTK_WINDOW (dia_grablist_insert), FALSE, FALSE, FALSE);

  dialog_vbox5 = GNOME_DIALOG (dia_grablist_insert)->vbox;
  gtk_object_set_data (GTK_OBJECT (dia_grablist_insert), "dialog_vbox5", dialog_vbox5);
  gtk_widget_show (dialog_vbox5);

  vbox8 = gtk_vbox_new (TRUE, 0);
  gtk_widget_ref (vbox8);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "vbox8", vbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox8);
  gtk_box_pack_start (GTK_BOX (dialog_vbox5), vbox8, TRUE, TRUE, 0);

  vbox9 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox9);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "vbox9", vbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox9);
  gtk_box_pack_start (GTK_BOX (vbox8), vbox9, FALSE, FALSE, 0);

  dia_datainsert_src = gtk_label_new ( srchostinfo);
  gtk_widget_ref (dia_datainsert_src);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "dia_datainsert_src", dia_datainsert_src,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dia_datainsert_src);
  gtk_box_pack_start (GTK_BOX (vbox9), dia_datainsert_src, FALSE, FALSE, 0);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox9), hseparator1, TRUE, TRUE, 0);

  hbox1 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox8), hbox1, TRUE, TRUE, 0);

  dia_dtist_src_port = gtk_toggle_button_new_with_label (_("insert port"));
  gtk_widget_ref (dia_dtist_src_port);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "dia_dtist_src_port", dia_dtist_src_port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dia_dtist_src_port);
  gtk_box_pack_start (GTK_BOX (hbox1), dia_dtist_src_port, FALSE, FALSE, 0);

  dia_dtist_src_cont = gtk_toggle_button_new_with_label (_("insert cont"));
  gtk_widget_ref (dia_dtist_src_cont);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "dia_dtist_src_cont", dia_dtist_src_cont,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dia_dtist_src_cont);
  gtk_box_pack_start (GTK_BOX (hbox1), dia_dtist_src_cont, FALSE, FALSE, 0);

  dia_dtist_src_site = gtk_toggle_button_new_with_label (_("insert site"));
  gtk_widget_ref (dia_dtist_src_site);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "dia_dtist_src_site", dia_dtist_src_site,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dia_dtist_src_site);
  gtk_box_pack_start (GTK_BOX (hbox1), dia_dtist_src_site, FALSE, FALSE, 0);

  vbox10 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox10);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "vbox10", vbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox10);
  gtk_box_pack_start (GTK_BOX (vbox8), vbox10, FALSE, FALSE, 0);

  dia_datainsert_dst = gtk_label_new ( dsthostinfo);
  gtk_widget_ref (dia_datainsert_dst);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "dia_datainsert_dst", dia_datainsert_dst,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dia_datainsert_dst);
  gtk_box_pack_start (GTK_BOX (vbox10), dia_datainsert_dst, FALSE, FALSE, 0);

  hseparator2 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator2);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "hseparator2", hseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator2);
  gtk_box_pack_start (GTK_BOX (vbox10), hseparator2, TRUE, TRUE, 0);

  hbox2 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox8), hbox2, TRUE, TRUE, 0);

  dia_dtist_dst_port = gtk_toggle_button_new_with_label (_("insert port"));
  gtk_widget_ref (dia_dtist_dst_port);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "dia_dtist_dst_port", dia_dtist_dst_port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dia_dtist_dst_port);
  gtk_box_pack_start (GTK_BOX (hbox2), dia_dtist_dst_port, FALSE, FALSE, 0);

  dia_dtist_dst_cont = gtk_toggle_button_new_with_label (_("insert cont"));
  gtk_widget_ref (dia_dtist_dst_cont);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "dia_dtist_dst_cont", dia_dtist_dst_cont,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dia_dtist_dst_cont);
  gtk_box_pack_start (GTK_BOX (hbox2), dia_dtist_dst_cont, FALSE, FALSE, 0);

  dia_dtist_dst_site = gtk_toggle_button_new_with_label (_("insert site"));
  gtk_widget_ref (dia_dtist_dst_site);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "dia_dtist_dst_site", dia_dtist_dst_site,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dia_dtist_dst_site);
  gtk_box_pack_start (GTK_BOX (hbox2), dia_dtist_dst_site, FALSE, FALSE, 0);

  dialog_action_area5 = GNOME_DIALOG (dia_grablist_insert)->action_area;
  gtk_object_set_data (GTK_OBJECT (dia_grablist_insert), "dialog_action_area5", dialog_action_area5);
  gtk_widget_show (dialog_action_area5);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area5), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area5), 8);

  gnome_dialog_append_button (GNOME_DIALOG (dia_grablist_insert), GNOME_STOCK_BUTTON_OK);
  dia_dtist_ok_btt = g_list_last (GNOME_DIALOG (dia_grablist_insert)->buttons)->data;
  gtk_widget_ref (dia_dtist_ok_btt);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "dia_dtist_ok_btt", dia_dtist_ok_btt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dia_dtist_ok_btt);
  GTK_WIDGET_SET_FLAGS (dia_dtist_ok_btt, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (dia_grablist_insert), GNOME_STOCK_BUTTON_APPLY);
  dia_dtist_adp_btt = g_list_last (GNOME_DIALOG (dia_grablist_insert)->buttons)->data;
  gtk_widget_ref (dia_dtist_adp_btt);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "dia_dtist_adp_btt", dia_dtist_adp_btt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dia_dtist_adp_btt);
  GTK_WIDGET_SET_FLAGS (dia_dtist_adp_btt, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (dia_grablist_insert), GNOME_STOCK_BUTTON_CANCEL);
  dia_dtist_cc_btt = g_list_last (GNOME_DIALOG (dia_grablist_insert)->buttons)->data;
  gtk_widget_ref (dia_dtist_cc_btt);
  gtk_object_set_data_full (GTK_OBJECT (dia_grablist_insert), "dia_dtist_cc_btt", dia_dtist_cc_btt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dia_dtist_cc_btt);
  GTK_WIDGET_SET_FLAGS (dia_dtist_cc_btt, GTK_CAN_DEFAULT);
  
  
  	mybdwgt = ( struct my_widget_bundle *) malloc( sizeof( struct my_widget_bundle));	
	mybdwgt->item1 = dia_dtist_src_port;
	mybdwgt->item2 = dia_dtist_src_cont;
	mybdwgt->item3 = dia_dtist_src_site;
	mybdwgt->item4 = dia_dtist_dst_port;
	mybdwgt->item5 = dia_dtist_dst_cont;
	mybdwgt->item6 = dia_dtist_dst_site;
	mybdwgt->item7 = dia_grablist_insert;	

  gtk_signal_connect (GTK_OBJECT (dia_dtist_ok_btt), "clicked",
                      GTK_SIGNAL_FUNC (on_dia_dtist_ok_btt_clicked),
                      (gpointer) mybdwgt);
  gtk_signal_connect (GTK_OBJECT (dia_dtist_adp_btt), "clicked",
                      GTK_SIGNAL_FUNC (on_dia_dtist_adp_btt_clicked),
                      (gpointer) mybdwgt);
  gtk_signal_connect (GTK_OBJECT (dia_dtist_cc_btt), "clicked",
                      GTK_SIGNAL_FUNC (on_dia_dtist_cc_btt_clicked),
                      (gpointer) mybdwgt);
  gtk_signal_connect (GTK_OBJECT ( dia_grablist_insert), "delete_event",
                      GTK_SIGNAL_FUNC ( insert_data_obj_del),
                      (gpointer) mybdwgt);	

  return dia_grablist_insert;
}

