
#include <pthread.h>
#include <pcap/pcap.h> 
#include <netinet/ip.h>
#include <stdio.h>
#include <gnome.h>


#include "interface.h"
#include "support.h"
#include "thpkt.h"
#include "nameconv.h"

struct my_link_list					*pkt_data = NULL;
pthread_mutex_t					pkt_data_mutex = PTHREAD_MUTEX_INITIALIZER;


int									ini_th_pkt( void)
{
	struct	bpf_program				fcode;
	char								*device = NULL;
	char								*filter_rule;
	char    								ebuf[PCAP_ERRBUF_SIZE];
	pcap_t								*pd;
	pthread_t							tid;
	bpf_u_int32 						localnet, netmask;
	

	
	
	filter_rule = "tcp and tcp[13:1] & 2 != 0";
	device = pcap_lookupdev(ebuf);

	if(device == NULL) {
   		perror(ebuf);           
   		exit( 1);
   	}

	pd = pcap_open_live(device, 68, 1, 1000, ebuf);
	if(pd == NULL) {
   		perror(ebuf);          
   		exit(1);
   	}
	

	if( 68 < pcap_snapshot(pd)) {
   		perror(ebuf);                            
  		exit(1);
   	}

	if(pcap_lookupnet(device, &localnet, &netmask, ebuf) < 0) {
   		perror(ebuf);
   		exit(1);
   	}
	

	if(pcap_compile(pd, &fcode, filter_rule, 0, netmask) < 0) {
   		perror(ebuf);
   		exit(1);
   	}

	if(pcap_setfilter(pd, &fcode) < 0) {
   		perror(ebuf);
   		exit(1);
   	}

	if( pcap_datalink(pd) != DLT_EN10MB){
		
		printf("not support this ll");
		exit(1);
		
	}
	

	

	if ( pthread_create( &tid, NULL, &th_pkt_loop, pd) )
		fprintf(stderr,"Thread creation error!\n");
	

}


void					*th_pkt_loop(

	void					*user_data)

{
	
	char					*pkt_ptr;
	
	struct	pcap_pkthdr	hdr;	
	struct	u_layer_hdr	*upperh; 	
	struct	iphdr			*iphp;
	struct	my_link_list	*data;
	struct	my_link_list	*data_p;
	
	pcap_t					*pd;
	

	
	
	pthread_detach ( pthread_self () );
	
	pd = user_data;

	while(1){
	
		while( ( pkt_ptr = (char *) pcap_next( pd, &hdr)) == NULL) ;
    		
		pkt_ptr = (pkt_ptr + 14);
		iphp = (struct  iphdr *) pkt_ptr;
		upperh = (struct u_layer_hdr *) ( pkt_ptr + iphp->ihl * 4);
		
		pthread_mutex_lock( &pkt_data_mutex);
	
		for( data_p = data = pkt_data; data != NULL; data = data->next){
			
			if( data->srcip == iphp->saddr){
				if( data->dstip == iphp->daddr){
					if( data->srcport == upperh->source){
						if( data->dstport == upperh->dest){
							break;
						}
					}
				}
			}
			
			data_p = data;
		}
		
		if( data == NULL){
		
			data = (struct my_link_list *) malloc( sizeof( struct my_link_list));
			pthread_mutex_unlock( &pkt_data_mutex);		
			djsc_gethostbyaddr( iphp->saddr, data->srchostname);
			djsc_gethostbyaddr( iphp->daddr, data->dsthostname);					
			pthread_mutex_lock( &pkt_data_mutex);
			data->next = NULL;
			data->srcip = iphp->saddr;
			data->dstip = iphp->daddr;
			data->srcport = upperh->source;
			data->dstport = upperh->dest;
			
			if( pkt_data == NULL)
				pkt_data = data;
			else{
				data_p->next = data;					
			}			
						
		}
				
			
	pthread_mutex_unlock( &pkt_data_mutex);		
		
	}
	
	return (NULL);

}     
